<template>
    <equation-button :editor="editor" />
    <bubble-menu class="the-editor-bubble-menu" :tippy-options="{placement: 'bottom'}" :editor="editor" plugin-key="link-preview" :should-show="shouldShowPreview">
        <div style="display: flex; gap: 4px; align-items: baseline;">
            <span>{{ preview?.raw }}</span>
            <button type="button" class="the-editor-bubble-menu-button" @click="()=>{editEquation(editor)}"><pencil/></button>
        </div>
    </bubble-menu>
</template>

<script setup lang="ts">
import { computed, ref } from 'vue';
import makeButton from '../makeButton';
import makeIcon from '../makeIcon';
import { BubbleMenu } from '@tiptap/vue-3';
import type { TheEditor } from '../TheEditor';
import {Editor} from '@tiptap/core'

const props = defineProps<{
    editor: TheEditor,
}>()
const pencil = makeIcon('pencil', {size: 12})

const preview = ref<any|null>(null)
const shouldShowPreview = (ed: {editor: Editor, from: number, to: number}) => {
    // @ts-ignore
    if (ed.editor.view.state.selection.node?.type?.name == 'equation'){
        // @ts-ignore
        let val: string = ed.editor.view.state.selection.node.attrs.raw
        // Crop if too long
        if (val.length > 140) val = val.slice(0, 140) + '...'
        preview.value = {raw: val}
        return true
    }
    return false
}
const btn_active = computed(() => props.editor.isActive('equation'))

const editEquation = (ed: Editor) => {
        let options = ed.extensionManager.extensions.find(ex => ex.name == 'equation')?.options
        if (!options) return
        // @ts-ignore
        if (ed.view.state.selection?.node?.type?.name == 'equation'){
            // @ts-ignore
            options.openEquationDialog(ed, ed.view.state.selection.node.attrs)
        }
        else{
            options.openEquationDialog(ed)
        }
}
const EquationButton = makeButton({
    title: 'add/edit equation',
    content: makeIcon('equation'),
    active: _ed => btn_active.value,
    enabled: ed => ed.can().addEquation({raw: ''}),
    action: ed => {
        editEquation(ed)
    }
})
</script>